﻿local OWNMATSTIP, SELLWITHMATS, CUSTOM = 1, 2, 3
CraftBotFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0")

function CraftBotFu:OnInitialize()
	self.title = CRAFTBOT_MENU
	self.category = "Tradeskill"
	self.cannotDetachTooltip  = true
	self.tooltipHiddenWhenEmpty  = true
	self.cannotHideText = false
	self.cannotAttachToMinimap = true
	self.hasNoColor = true
	self.hasIcon = true
	self.OnMenuRequest = self:PrepareMenu()
	self:SetIcon(true)
	self:RegisterDB("CraftBotFuDB")
end

function CraftBotFu:ToggleSilent()
	CraftBot_Silent = not CraftBot_Silent
	self:Update()
end

function CraftBotFu:ToggleStartStop()
	CraftBot_On = not CraftBot_On
	self:Update()
end

function CraftBotFu:PrepareMenu()
	local options = {
		type = 'group',
		args = {
			start = {
				type = "toggle",
				name = CRAFTBOT_MENU_ENABLE,
				desc = CRAFTBOTFU_ENABLE_DESC,
				get = function () return CraftBot_On end,
				set = "ToggleStartStop",
				order = 100,
		        },
			options = {
				type = "group",
				name = CRAFTBOT_MENU_OPTION,
				desc = CRAFTBOTFU_OPTION_DESC,
				order = 200,
				args = {
				        limit = {
						type = "range",
						name = CRAFTBOT_MENU_LIMIT,
						desc = CRAFTBOTFU_LIMIT_DESC,
						max = 20,
						min = 0,
						step = 1,
						isPercent = false,
						get = function () return CraftBot_Limit end,
						set = function (v) CraftBot_Limit = v end,
						order = 100,
				        },
				        silent = {
						type = "toggle",
						name = CRAFTBOT_MENU_SILENT,
						desc = CRAFTBOTFU_SILENT_DESC,
						get = function () return CraftBot_Silent end,
						set = "ToggleSilent",
						order = 200,
				        }
				}
			}
		}
    	}
	return options
end

function CraftBotFu:OnDataUpdate()
end

function CraftBotFu:OnTextUpdate()
	if self:IsTextShown() then
		self:SetText(CraftBot_GetButtonText())
	end
end

local tablet = AceLibrary("Tablet-2.0")
function CraftBotFu:OnTooltipUpdate()
	local cat = tablet:AddCategory(
		'text', "",
		'columns', 1,
		'child_textR', 1,
		'child_textG', 1,
		'child_textB', 0
	)
	cat:AddLine(
		'text', CraftBot_GetTooltipText()
	)
	tablet:SetHint(CRAFTBOT_HINT)
end

function CraftBotFu:OnClick()
	CraftBot_ToggleOptions()
end
